package cz.dix.pe.problems;

/**
 * The sequence of triangle numbers is generated by adding the natural numbers. So the 7th triangle number would be 1 + 2 + 3 + 4 + 5 + 6 + 7 = 28. The first ten terms would be:
 * <p/>
 * 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, ...
 * <p/>
 * Let us list the factors of the first seven triangle numbers:
 * <p/>
 * 1: 1
 * 3: 1,3
 * 6: 1,2,3,6
 * 10: 1,2,5,10
 * 15: 1,3,5,15
 * 21: 1,3,7,21
 * 28: 1,2,4,7,14,28
 * We can see that 28 is the first triangle number to have over five getDivisors.
 * <p/>
 * What is the value of the first triangle number to have over five hundred getDivisors?
 */
public class Problem12 implements Problem {

    @Override
    public Object solve() {
        int factorsCount = 500;

//        final int NUMS_TESTED = 30000; // 50k
//        List<Boolean[]> factorsList = new ArrayList<Boolean[]>(NUMS_TESTED);
//        for (int i = 0; i < NUMS_TESTED; i++) {
//            Boolean[] isFactorArray = new Boolean[NUMS_TESTED];
//            Arrays.fill(isFactorArray, false);
//            factorsList.add(isFactorArray);
//        }
//
//        for (int idx = 0; idx < NUMS_TESTED; idx++) {
//            int num = idx + 1;
//            Boolean[] isFactorArray = factorsList.get(idx);
//
//            int numSum = 0;
//            while (numSum < isFactorArray.length) {
//                isFactorArray[numSum] = true;
//                numSum += num;
//            }
//        }
//
//
//        for (int num = 5; num < Integer.MAX_VALUE; num++) {
//            int triangleNum = (num * (num + 1)) / 2;
//            if (triangleNum > NUMS_TESTED) {
//                throw new RuntimeException("Raise count of tested numbers");
//            }
//            int numFactorsCount = 2; // 1 and original number are always factors
//            for (int factorCandidate = 2; factorCandidate <= triangleNum / 2; factorCandidate++) {
//                if (factorsList.get(factorCandidate - 1)[triangleNum]) {
//                    numFactorsCount++;
//                }
//                if (numFactorsCount > factorsCount) {
//                    return triangleNum;
//                }
//            }
//        }
//        throw new RuntimeException("Raise count of tested numbers");


        // I switched to brute force due to heap space
        for (int num = 5; num < Integer.MAX_VALUE; num++) {
            long triangleNum = (num * (num + 1)) / 2;
            int numFactorsCount = 2; // 1 and original number are always factors
            for (long factorCandidate = 2; factorCandidate <= triangleNum / 2; factorCandidate++) {
                if (triangleNum % factorCandidate == 0) {
                    numFactorsCount++;
                }
                if (numFactorsCount > factorsCount) {
                    return triangleNum; // 76576500
                }
            }
        }
        throw new RuntimeException("No such number exists");
    }
}
